function fov(obj)

	local o = 	{
				{	yStep = -1,	xStep = -1	},
				{	yStep = -1,	xStep = 1	},
				{	yStep = -1,	xStep = 1	},
				{	yStep = 1,	xStep = 1	},
				{	yStep = 1,	xStep = 1	},
				{	yStep = 1,	xStep = -1	},
				{	yStep = 1,	xStep = -1	},
				{	yStep = -1,	xStep = -1	}
				}

	for v=1, 8 do

		if v == 3 or v == 5 or v == 7 then
		
			obj.x, obj.y = obj.y, obj.x
			o[v].yStep, o[v].xStep = o[v].xStep, o[v].yStep
			mapW, mapH = mapH, mapW
			
		end
		newScan(obj, v, obj.y, o[v].yStep, o[v].xStep, 1, 0)

	end
	obj.x, obj.y = obj.y, obj.x
	mapW, mapH = mapH, mapW
	
end

-- a/n/p Slp/Nd = actual/next/previous slope/node

function newScan(obj, oct, start, yStep, xStep, sSlp, eSlp)

	local msg = "set"
	local x, y
	local ss, es = sSlp, eSlp
	for y = start + yStep, obj.y + mapH * yStep, yStep do	--mapH is enough - when @ is at 1 then 1+mapH gives oposite limit

		if map[y] then	--this is safe since yMin is 1 so y-1=0 and there is no map[0] (same applies to other limit) (THIS CANNOT BE DONE WITH "X" but it is ok for fov() to highlight the walls on the edges because Y (or x after swapping) is main direction in each octane)

			msg = "set"
			for x = obj.x + (math.abs(obj.y - y)) * xStep, obj.x, xStep * (-1) do
					
				if x > 1 and x < mapW then	-- cannot be <= / >= because there must be a room for pNd - but anyway this is working I think because x and y swaps and other octane is highlighting them

					local distX = obj.x - x
					local distY = obj.y - y
					local aSlp = math.abs(distX / distY)

					local aNd = map[y][x]	--actual
					local pNd = map[y][x + xStep]	--horizontaly away
					local xNd = map[y - yStep][x + xStep]	--vertically closer to the source and horizontally away
					local dNd = map[y - yStep][x]	--verticaly closer
					if oct == 3 or oct == 4 or oct == 7 or oct == 8 then

						aNd = map[x][y]
						pNd = map[x + xStep][y]
						xNd = map[x + xStep][y - yStep]
						dNd = map[x][y - yStep]
						
					end
					if (aSlp <= sSlp) and (aSlp >= eSlp) then

						local pSlp = math.abs((obj.x - (x + xStep)) / distY)					
						if msg == "set" then msg = nil end
						
						if aNd.walkable ~= pNd.walkable then
						
							if aNd.walkable == 1 then
							
								msg = "start"
								ss = aSlp
								if pSlp <= 1 then
								
									pNd.visible = 1
									
								end
								
							else
							
								msg = "end"
								newScan(obj, oct, y, yStep, xStep, ss, pSlp)	--using previous slope because active one is a blocker
							
							end
							
						end
						local nSlp = ((obj.x - (x - xStep)) / distY) * yStep * xStep	--uwzgledniny znak oktany jesli nSlp przejdzie 0
						if nSlp < eSlp and msg == "start" and aNd.walkable == 1 then
						
							newScan(obj, oct, y, yStep, xStep, ss, eSlp)
							
						end
						if aNd.walkable == 0 then msg = "solid" end
						aNd.visible = 1
						-- highlight all the corners in fov
						if aNd.walkable == 0 and pNd.walkable == 0 and xNd.walkable == 0 and dNd.walkable == 1 and pSlp <= 1 then
							
							pNd.visible = 1
						
						end
						--highlight all units in fov
						if aNd.units and aNd.units ~= -1 then
						
							units[aNd.units].visible = 1
						
						end

					end	--check if xy are within slopes (and in rang eventually)
				end	--check if x is on the map
			end	--x loop (inner)
		end	--checkif y is on the map
		if msg then break end
	end	--y loop (outer)
end