fs = 12
mapW, mapH = 50, 50	--narazie musi mapW = mapH - bo pieprzy sie fov()
roomCol = 0	--min 0
map = {}
nodes = {}
items = {}
units = {}
one = 0
asta = 0
zet = 1
bspLvl = 4	--0 means 1 room
wShift = 0	--0 means walls can overlap
rMin = 5	--min 1
rMax = 20	--min 1
monNo = 10
monData = {}
spdTable = {}
dict = {}
gameState = "play"
space = 0

require("run")
require("astar")
require("bsp")
require("fov")
require("items")
require("itemsPopulate")
require("menu")
require("monsterMove")
require("player")
require("units")

function love.load()
	love.filesystem.setIdentity("dictionary")
	for line in love.filesystem.lines("dictionary/pol-eng.txt") do
		table.insert(dict, line)
	end
	
	
	tileset = love.graphics.newImage("pic.png")
	tileW, tileH = fs, fs
	local tilesetW, tilesetH = tileset:getWidth(), tileset:getHeight()	
	quads = {
			love.graphics.newQuad(0, 0, tileW, tileH, tilesetW, tilesetH),
			love.graphics.newQuad(12, 0, tileW, tileH, tilesetW, tilesetH),
			love.graphics.newQuad(0, 12, tileW, tileH, tilesetW, tilesetH),
			love.graphics.newQuad(12, 12, tileW, tileH, tilesetW, tilesetH)
			}
	fontDeja = love.graphics.newFont("DejaVuSansMono.ttf", fs)
	love.graphics.setFont(fontDeja)
	spdTable = {}
	monData = {}
	generateMap()
	aStarPreset()
	itemsStairs()
	makeUnits(monNo)
end

function love.keypressed(key)
	if key == "escape" then
		return love.event.push("quit") 
	elseif key == "return" then
		spdTable = {}
		monData = {}
		generateMap()
		aStarPreset()
		itemsStairs()
		makeUnits(monNo)
	elseif key == "tab" and gameState == "play" then
		gameState = "menu"
	elseif key == "tab" and gameState == "menu" then		
		gameState = "play"
	elseif key == "1" then
		if one == 0 then one = 1 else one = 0 end
	elseif key == "x" then
		if asta == 0 then asta = 1 else asta = 0 end
	elseif key == "z" then
		if zet == 0 then zet = 1 else zet = 0 end
	end
	if love.keyboard.isDown("lshift") and key == "." and map[units[1].y][units[1].x].items == "stairs_down" then
		spdTable = {}
		monData = {}
		generateMap()
		aStarPreset()
		itemsStairs()
		makeUnits(monNo)
	end
	if gameState == "play" then
		player.keyPressed(key)
		makeMove()
		fov(hero)
	elseif gameState == "menu" then
		menu.keyPressed(key)
	end
	-- if hero.x ~= items["stairs_down"].x or hero.y ~= items["stairs_down"].y then
		-- aStar(hero,items["stairs_down"])
	-- end
	redrawAll()
end

function love.draw()
	menu.draw()
	bsp.draw()
	player.draw()
	player.neighbours()
	if units then
		for k, v in ipairs(units) do
			love.graphics.setColor(unpack(units[k].color))
			if units[k].visible == 1 and zet == 1 then
				love.graphics.drawq(tileset, quads[3], (units[k].x-1)*fs, (units[k].y-1)*fs)
				units[k].visible = 0
			elseif units[k].visible == 1 and zet ~= 1 then
				love.graphics.print(units[k].glyph, (units[k].x-1)*fs, (units[k].y-1)*fs)
				units[k].visible = 0
			end
		end
	end
	-- if asta == 1 then
		-- love.graphics.setColor(0,255,0,255)
		-- for k,v in ipairs(hero.path) do
			-- love.graphics.print("+",(v.x - 1)*fs,(v.y-1) * fs)
		-- end
	-- end
end
