function makeMove()
	local u, x, y
	
	hero.action[4] = hero.action[3]/hero.spd
	hero.timer = hero.timer + hero.action[4]
	
	if #spdTable == 0 then
		for i, v in ipairs(units) do
			nextMove(i)
			updSpdTbl(i)
		end
		updSpdTbl(-1)
	else
		updSpdTbl(-1) -- to by wstawic [hero] na nowo do spdTable
	end
	
	repeat
		local id = spdTable[1][1]
		
		u = id == -1 and hero or units[id]
		x = u.x + u.action[1]
		y = u.y + u.action[2]
		
		local nNd = map[y][x]
		
		if nNd.units == nil or nNd.units == id then
			map[u.y][u.x].units = nil
			u.x = x
			u.y = y
			nNd.units = id
			if id == -1 then
				table.remove(spdTable, 1)
				break
			end
			table.remove(spdTable, 1)
			nextMove(id)
			updSpdTbl(id)
		else
			if id == -1 then
				table.remove(spdTable, 1)
				break
			end
			if nNd.units ~= -1 then
				nextMove(nNd.units)
			end
			if nNd.units == -1 then
				u.timer = hero.timer + u.action[4]
			else
				u.timer = units[nNd.units].timer + u.action[4]
			end
			table.remove(spdTable, 1)
			updSpdTbl(id)
		end
	until false
end


function nextMove(id)

	local dir = {}
	local u = units[id]
	local mark = false

	for y = -1, 1 do
		for x = -1, 1 do
			if map[u.y + y][u.x + x].walkable == 1 and map[u.y + y][u.x + x].units == nil then

				table.insert(dir, {x, y, x * y ~= 0 and 14 or 10})
				if u.action[1] == x and u.action[2] == y then
				
					mark = true
				
				end
			end
		end
	end

	if #dir == 0 then
	
		u.action = {0, 0, 10}
		u.action[4] = u.action[3] / u.spd
	
	elseif	#dir > 0 and not mark then
		
		u.action = dir[math.random(#dir)]
		u.action[4] = u.action[3] / u.spd
		
	end
	u.timer = u.timer + u.action[4]
end


function updSpdTbl(id)
	
	local u
	
	u = id == -1 and hero or units[id]
	
	local ikey = false

	for i, v in ipairs(spdTable) do
		if u.timer < v[2] then
			ikey = i
			break
		end
	end

	if ikey then
		table.insert(spdTable, ikey, {id, u.timer})
	else
		table.insert(spdTable, {id, u.timer})
	end
end
