player = {}

function player.keyPressed(key)

	local x = hero.x
	local y = hero.y
	hero.action = {0, 0, 10}


	if love.keyboard.isDown("lctrl") and key == "left" and map[y-1][x-1].walkable == 1 then
		hero.action = {-1, -1, 14}
	elseif love.keyboard.isDown("lctrl") and key == "right" and map[y+1][x+1].walkable == 1 then
		hero.action = {1, 1, 14}
	elseif love.keyboard.isDown("lctrl") and key == "up" and map[y-1][x+1].walkable == 1 then
		hero.action = {1, -1, 14}
	elseif love.keyboard.isDown("lctrl") and key == "down" and map[y+1][x-1].walkable == 1 then
		hero.action = {-1, 1, 14}
	elseif key == "left" and map[y][x-1].walkable == 1 then
		hero.action = {-1, 0, 10}
	elseif key == "right" and map[y][x+1].walkable == 1 then
		hero.action = {1, 0, 10}
	elseif key == "up" and map[y-1][x].walkable == 1 then
		hero.action = {0, -1, 10}
	elseif key == "down" and map[y+1][x].walkable == 1 then
		hero.action = {0, 1, 10}
	end
	
	if key == "space" then
		space = space == 0 and 1 or 0
	end
end



function player.draw()
	if space == 1 then
		love.graphics.rectangle("fill",50,50,200,50)
	end

	if zet == 1 then
		love.graphics.drawq(tileset, quads[4], (hero.x-1)*fs, (hero.y-1)*fs)
	else
		love.graphics.print(hero.glyph, (hero.x-1)*fs, (hero.y-1)*fs)
	end
end


function player.neighbours()

	local x = hero.x
	local y = hero.y
	for b = -1, 1 do
		for a = -1, 1 do
			if map[y + b][x + a].units and map[y + b][x + a].units ~= -1 then
				local u = units[map[y + b][x + a].units]
				if u.items then
					u.text = love.graphics.rectangle("fill", u.x * fs, u.y * fs, 100, 20)
				end
			end
		end
	end
end