
function makeUnits(_howMany)

	hero	=	{
				action		= {0, 0, 10},
				color		= {255, 255, 255, 255},
				glyph		= "@",
				id			= -1,
				items		= nil,
				name		= "hero",
				path		= {},
				spd			= 10,
				text		= nil,
				timer		= 0,
				visible		= 1,
				walkable	= 0,
				x			= items["stairs_up"].x,
				y			= items["stairs_up"].y
				}
					
	hero.action[4] = hero.action[3]/hero.spd


	units = {}
	for i = 1, _howMany do

		local rnd = math.random(#nodes)
		local nd = nodes[rnd]
		map[nd.y][nd.x].units = i
		table.remove(nodes,rnd)
		units[i]	=	{
						action		= {0, 0, 10},
						color		= {255, 0, 0, 255},
						glyph		= i,
						id			= i,
						items		= dict[math.random(#dict)],
						name		= i,
						path		= {},
						spd			= math.random(5,20),
						text		= nil,
						timer		= 0,
						visible		= 0,
						walkable	= 0,
						x			= nd.x,
						y			= nd.y
						}
					
		units[i].action[4] = units[i].action[3]/units[i].spd
	end
end	